## mlt 6.22.1

=== CMakeLists.txt ===
project(MLT)
set(MLT_VERSION 6.22.1)
cmake_minimum_required(VERSION 3.10)
find_package(PkgConfig REQUIRED)
include(GNUInstallDirs)
option(GPL "Enable GPLv2 modules" ON)
option(GPL3 "Enable GPLv3 modules" ON)
if(WIN32)
  option(NODEPLOY "Keep bin/ lib/ layout on Windows" ON)
endif()
if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86_64)|(AMD64)")
    set(X86_64 ON)
    if(NOT MSVC)
        add_definitions(-DUSE_MMX -DUSE_SSE -DUSE_SSE2 -DARCH_X86_64)
    endif()
endif()
if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
    add_compile_options(-ffast-math)
elseif(MSVC)
    add_compile_options(/fp:fast)
endif()
find_package(Threads REQUIRED)
find_package(FFTW QUIET)
if(NOT FFTW_FOUND)
    pkg_check_modules(FFTW fftw3)
endif()
if(NOT FFTW_FOUND)
    pkg_check_modules(FFTW fftw)
endif()
pkg_check_modules(xml IMPORTED_TARGET libxml-2.0)
add_subdirectory(src/framework)
add_subdirectory(src/melt)
add_subdirectory(src/mlt++)
#add_subdirectory(src/swig)
#file(GLOB modules src/modules/*/)
set(modules
    src/modules/avformat
    src/modules/core
    src/modules/decklink
    src/modules/frei0r
    src/modules/feeds
    src/modules/gdk
    src/modules/jackrack
    src/modules/kdenlive
    src/modules/motion_est
    src/modules/normalize
    src/modules/oldfilm
    src/modules/opencv
    src/modules/opengl
    src/modules/plus
    src/modules/plusgpl
    src/modules/qt
    src/modules/resample
    src/modules/rubberband
    src/modules/rtaudio
    src/modules/sdl2
    src/modules/sox
    src/modules/vid.stab
    src/modules/vmfx
    src/modules/vorbis
    src/modules/xine
    src/modules/xml
    src/modules/lumas
)
foreach(module ${modules})
    add_subdirectory(${module})
endforeach()
install(DIRECTORY profiles DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt)
install(DIRECTORY presets DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt)

=== src/framework/CMakeLists.txt ===
file(GLOB mlt_src *.c)
if(WIN32)
    list(APPEND mlt_src ../win32/win32.c ../win32/strptime.c)
endif()
add_library(mlt SHARED ${mlt_src})
set_target_properties (mlt PROPERTIES SOVERSION ${MLT_VERSION} VERSION 6)
if(WIN32)
    find_package(dlfcn-win32 REQUIRED)
    find_package(iconv REQUIRED)
    target_link_libraries(mlt dlfcn-win32::dl Iconv::Iconv)
    if(NODEPLOY)
        target_compile_definitions(mlt PRIVATE NODEPLOY)
    endif()
else()
    target_link_libraries(mlt dl)
endif()
if(NOT (WIN32 OR APPLE))
    target_compile_definitions(mlt PRIVATE
        PREFIX_DATA="${CMAKE_INSTALL_FULL_DATADIR}/mlt"
        PREFIX_LIB="${CMAKE_INSTALL_FULL_LIBDIR}/mlt")
endif()

target_link_libraries(mlt m Threads::Threads)
target_include_directories(mlt PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_include_directories(mlt PUBLIC  ${CMAKE_SOURCE_DIR}/src)

if(WIN32)
    install(TARGETS mlt DESTINATION ${CMAKE_INSTALL_BINDIR})
else()
    install(TARGETS mlt DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

file(GLOB mlt_head *.h)
install(FILES ${mlt_head} DESTINATION include/mlt/framework)

configure_file(mlt-framework.pc.in mlt-framework.pc @ONLY)
install (FILES
    ${CMAKE_CURRENT_BINARY_DIR}/mlt-framework.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT Development)
#configure_file(MLTConfig.cmake.in MLTConfig.cmake @ONLY)
#configure_file(MLTConfigVersion.cmake.in MLTConfigVersion.cmake @ONLY)
#install (FILES
#    ${CMAKE_CURRENT_BINARY_DIR}/MLTConfig.cmake
#    ${CMAKE_CURRENT_BINARY_DIR}/MLTConfigVersion.cmake
#    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/mlt
#    COMPONENT Development)

=== src/mlt++/Makefile ===
include ../../config.mak
include config.mak
INSTALL = install

NAME = libmlt++$(LIBSUF)
ifeq ($(targetos), Darwin)
	TARGET = libmlt++.$(version)$(LIBSUF)
	SONAME = libmlt++.$(soversion)$(LIBSUF)
	LIBFLAGS += -install_name $(libdir)/$(SONAME) -current_version $(version) -compatibility_version $(soversion)
else ifeq ($(targetos), MinGW)
	TARGET = libmlt++-$(soversion)$(LIBSUF)
	CXXFLAGS += -DMLTPP_EXPORTS
	LIBFLAGS += -Wl,--output-def,libmlt++.def
else
	TARGET = $(NAME).$(version)
	SONAME = $(NAME).$(soversion)
	LIBFLAGS += -Wl,-soname,$(SONAME)
endif
ifneq (, $(shell $(CXX) --version | grep -is -e g++ -e clang))
	CXXFLAGS += -std=c++11
endif
CXXFLAGS += -I.. $(RDYNAMIC) -DVERSION=\"$(version)\" -fvisibility=hidden

LDFLAGS := -L../framework -lmlt $(LDFLAGS)
ifeq ($(targetos), Linux)
LDFLAGS += -Wl,--version-script=mlt++.vers
endif

OBJS = MltAudio.o \
	   MltAnimation.o \
	   MltConsumer.o \
	   MltDeque.o \
	   MltEvent.o \
	   MltFactory.o \
	   MltField.o \
	   MltFilter.o \
	   MltFilteredConsumer.o \
	   MltFilteredProducer.o \
	   MltFrame.o \
	   MltGeometry.o \
	   MltMultitrack.o \
	   MltParser.o \
	   MltPlaylist.o \
	   MltProducer.o \
	   MltProfile.o \
	   MltProperties.o \
	   MltPushConsumer.o \
	   MltRepository.o \
	   MltService.o \
	   MltTokeniser.o \
	   MltTractor.o \
	   MltTransition.o

SRCS = $(OBJS:.o=.cpp)
HEADERS = MltConfig.h Mlt.h $(OBJS:.o=.h)

all:		$(TARGET)

$(TARGET):	$(OBJS)
	$(CXX) $(LIBFLAGS) -o $@ $(OBJS) $(LDFLAGS)
	ln -sf $(TARGET) $(NAME)
	if [ "$(targetos)" != "MinGW" ]; then \
		ln -sf $(TARGET) $(SONAME) ; \
	fi

depend:	$(SRCS)
	$(CXX) -MM $(CXXFLAGS) $^ 1>.depend

clean:
	$(RM) $(OBJS) $(TARGET) $(NAME) $(SONAME) libmlt++.def

distclean:	clean

install:
	$(INSTALL) -d "$(DESTDIR)$(libdir)"
	if [ "$(targetos)" = "MinGW" ]; then \
		if [ "$(windeploy)" = true ]; then \
			$(INSTALL) -m 755 $(TARGET) "$(DESTDIR)$(prefix)" ; \
			$(INSTALL) -m 755 $(TARGET) "$(DESTDIR)$(libdir)/libmlt++.dll" ; \
		else \
			$(INSTALL) -m 755 $(TARGET) "$(DESTDIR)$(bindir)" ; \
			$(INSTALL) -m 755 $(TARGET) "$(DESTDIR)$(bindir)/libmlt++.dll" ; \
		fi; \
		$(INSTALL) -m 644 libmlt++.def "$(DESTDIR)$(libdir)" ; \
	else \
		$(INSTALL) -m 755 $(TARGET) $(DESTDIR)$(libdir) ; \
		ln -sf $(TARGET) $(DESTDIR)$(libdir)/$(SONAME) ; \
		ln -sf $(TARGET) $(DESTDIR)$(libdir)/$(NAME) ; \
	fi
	$(INSTALL) -d "$(DESTDIR)$(prefix)/include/mlt++"
	$(INSTALL) -m 644 $(HEADERS) "$(DESTDIR)$(prefix)/include/mlt++"

uninstall:
	rm -f "$(DESTDIR)$(libdir)/$(TARGET)"
	if [ "$(targetos)" != "MinGW" ]; then \
		rm -f "$(DESTDIR)$(libdir)/$(NAME)" ; \
		rm -f "$(DESTDIR)$(libdir)/$(SONAME)" ; \
	else \
		if [ "$(windeploy)" = true ]; then \
			rm -f "$(DESTDIR)$(prefix)/$(TARGET)" ; \
			rm -f "$(DESTDIR)$(libdir)/libmlt++.dll" ; \
		else \
			rm -f "$(DESTDIR)$(bindir)/$(TARGET)" ; \
			rm -f "$(DESTDIR)$(bindir)/libmlt++.dll" ; \
		fi ; \
		rm -f "$(DESTDIR)$(libdir)/libmlt++.def" ; \
	fi
	rm -rf "$(DESTDIR)$(prefix)/include/mlt++"

ifneq ($(wildcard .depend),)
include .depend
endif

=== src/modules/core/CMakeLists.txt ===
file(GLOB mltcore_src *.c)
set(mltcore_inc "")
if(WIN32)
    list(APPEND mltcore_src ${CMAKE_SOURCE_DIR}/src/win32/fnmatch.c)
    list(APPEND mltcore_inc ${CMAKE_SOURCE_DIR}/src/win32)
endif()
add_library(mltcore MODULE ${mltcore_src})
target_include_directories(mltcore PRIVATE ${mltcore_inc})
target_link_libraries(mltcore mlt Threads::Threads)
# Create module in parent directory, for the benefit of "source setenv".
set_target_properties(mltcore PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
install(TARGETS mltcore LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
file(GLOB yml *.yml)
install(FILES data_fx.properties loader.dict loader.ini ${yml}
    DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/core)

=== src/modules/frei0r/CMakeLists.txt ===
pkg_check_modules(FREI0R frei0r)
if(${FREI0R_FOUND})
    file(GLOB mltfrei0r_src *.c)
    add_library(mltfrei0r MODULE ${mltfrei0r_src})
    target_link_libraries(mltfrei0r mlt m dl)
    # Create module in parent directory, for the benefit of "source setenv".
    set_target_properties(mltfrei0r PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
    install(TARGETS mltfrei0r LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
    file(GLOB yml *.yml)
    install(FILES blacklist.txt not_thread_safe.txt param_name_map.yaml ${yml}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/frei0r)
endif()

=== src/modules/gdk/CMakeLists.txt ===
set(mltgdk_src factory.c)
set(mltgdk_lib mlt m Threads::Threads)
set(mltgdk_def "")


pkg_check_modules(GdkPixbuf IMPORTED_TARGET gdk-pixbuf-2.0 REQUIRED)
if(TARGET PkgConfig::GdkPixbuf)
    list(APPEND mltgdk_src producer_pixbuf.c pixops.c filter_rescale.c)
    list(APPEND mltgdk_lib PkgConfig::GdkPixbuf)
    list(APPEND mltgdk_def USE_PIXBUF)
    pkg_check_modules(libexif IMPORTED_TARGET libexif)
    if(TARGET PkgConfig::libexif)
        list(APPEND mltgdk_lib PkgConfig::libexif)
        list(APPEND mltgdk_def USE_EXIF)
    endif()
endif()

pkg_check_modules(pango IMPORTED_TARGET pango)
pkg_check_modules(fontconfig IMPORTED_TARGET fontconfig)
if(TARGET PkgConfig::pango AND TARGET PkgConfig::fontconfig)
    list(APPEND mltgdk_src producer_pango.c)
    list(APPEND mltgdk_lib PkgConfig::pango PkgConfig::fontconfig)
    list(APPEND mltgdk_def USE_PANGO)
endif()

# Only for MMX but not x86_64: deprecated
# list(APPEND mltgdk_src have_mmx.S scale_line_22_yuv_mmx.S)
add_library(mltgdk MODULE ${mltgdk_src})
target_link_libraries(mltgdk ${mltgdk_lib})
target_compile_definitions(mltgdk PRIVATE ${mltgdk_def})
# Create module in parent directory, for the benefit of "source setenv".
set_target_properties(mltgdk PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
install(TARGETS mltgdk LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
file(GLOB yml *.yml)
install(FILES ${yml}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/gdk)

=== src/modules/jackrack/CMakeLists.txt ===
#find_package(movit)
pkg_check_modules(jack IMPORTED_TARGET jack)
if(TARGET PkgConfig::jack)
    set(mltjack_src factory.c consumer_jack.c)
    set(mltjack_lib mlt Threads::Threads PkgConfig::jack)

    pkg_check_modules(glib IMPORTED_TARGET glib-2.0)
    check_include_file(ladspa.h ladspa)
    if(GPL AND TARGET PkgConfig::xml AND TARGET PkgConfig::glib AND ladspa)
        set(mltjack_src ${mltjack_src}
            jack_rack.c
            lock_free_fifo.c
            plugin.c
            plugin_desc.c
            plugin_mgr.c
            plugin_settings.c
            process.c
            producer_ladspa.c
            filter_jackrack.c
            filter_ladspa.c)
        set(mltjack_lib ${mltjack_lib} dl m PkgConfig::xml PkgConfig::glib)
        set(mltjack_def GPL)
        file(GLOB yml *.yml blacklist.txt)
    else()
        message(JACK NOGO)
        set(yml consumer_jack.yml)
    endif()
    add_library(mltjack MODULE ${mltjack_src})
    target_link_libraries(mltjack ${mltjack_lib})
    target_compile_definitions(mltjack PRIVATE ${mltjack_def})
    # Create module in parent directory, for the benefit of "source setenv".
    set_target_properties(mltjack PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
    install(TARGETS mltjack LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
    install(FILES ${yml} DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/jackrack)
endif()

=== src/modules/lumas/CMakeLists.txt ===
add_executable(luma luma.c)
target_link_libraries(luma mlt)
function(create_lumas dir w h bpp)
    set(${dir}
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma01.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma02.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma03.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma04.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma05.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma06.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma07.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma08.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma09.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma10.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma11.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma12.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma13.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma14.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma15.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma16.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma17.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma18.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma19.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma20.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma21.pgm
        ${CMAKE_CURRENT_BINARY_DIR}/${dir}/luma22.pgm
        )
    add_custom_command(OUTPUT ${${dir}} DEPENDS luma
        COMMAND ${CMAKE_COMMAND} -E make_directory ${dir}
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma01.pgm
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma02.pgm -bands ${h}
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma03.pgm -hmirror 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma04.pgm -bands ${h} -vmirror 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma05.pgm -offset 32768 -dmirror 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma06.pgm -offset 32768 -dmirror 1 -flip 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma07.pgm -offset 32768 -dmirror 1 -quart 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma08.pgm -offset 32768 -dmirror 1 -quart 1 -flip 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma09.pgm -bands 12 -rband 0
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma10.pgm -bands 12 -rband 0 -rotate 1 -flop 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma11.pgm -bands 12 -rband 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma12.pgm -bands 12 -rband 1 -vmirror 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma13.pgm -bands 12 -rband 1 -rotate 1 -flop 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma14.pgm -bands 12 -rband 1 -rotate 1 -flop 1 -vmirror 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma15.pgm -offset 32768 -dmirror 1 -hmirror 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma16.pgm -type 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma17.pgm -type 1 -bands 2 -rband 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma18.pgm -type 2
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma19.pgm -type 2 -quart 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma20.pgm -type 2 -quart 1 -flip 1
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma21.pgm -type 2 -quart 1 -bands 2
        COMMAND luma -w ${w} -h ${h} -bpp ${bpp} ${dir}/luma22.pgm -type 3)
    add_custom_target(${dir} ALL DEPENDS ${${dir}})
    install(FILES ${${dir}} DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/lumas/${dir})
endfunction()
create_lumas(PAL 720 576 16)
create_lumas(NTSC 720 480 16)
create_lumas(16_9 1920 1080 16)
create_lumas(9_16 1080 1920 16)
create_lumas(square 1080 1080 16)

=== src/modules/opencv/CMakeLists.txt ===
find_package(OpenCV QUIET OPTIONAL_COMPONENTS tracking)
if(${OpenCV_tracking_FOUND})
    add_library(mltopencv MODULE factory.c filter_opencv_tracker.cpp)
    target_link_libraries(mltopencv mlt ${OpenCV_LIBS})
    # Create module in parent directory, for the benefit of "source setenv".
    set_target_properties(mltopencv PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
    install(TARGETS mltopencv LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
    install(FILES filter_opencv_tracker.yml DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/opencv)
endif()

=== src/modules/opengl/CMakeLists.txt ===
#find_package(movit)
pkg_check_modules(movit IMPORTED_TARGET movit)
if(TARGET PkgConfig::movit)

    if(MINGW)
        set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} -lopengl32 -lpthread")
    endif()
    if(APPLE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -FOpenGL")
        set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} -lpthread -framework OpenGL")
    endif()

    pkg_get_variable(SHADERDIR movit shaderdir)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DSHADERDIR=\\\"${SHADERDIR}\\\"")

    file(GLOB mltopengl_src *.c *.cpp)
    add_library(mltopengl MODULE ${mltopengl_src})
    target_link_libraries(mltopengl mlt m PkgConfig::movit)
    # Create module in parent directory, for the benefit of "source setenv".
    set_target_properties(mltopengl PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
    install(TARGETS mltopengl LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
    file(GLOB yml *.yml)
    install(FILES ${yml} DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/opengl)
endif()

=== src/modules/opengl/Makefile ===
include ../../../config.mak

CFLAGS := -I../.. $(CFLAGS)

LDFLAGS := -L../../framework -lmlt -lm $(LDFLAGS)

TARGET = ../libmltopengl$(LIBSUF)

OBJS = factory.o

CPPOBJS = filter_glsl_manager.o
CPPOBJS += filter_movit_blur.o
CPPOBJS += filter_movit_convert.o
CPPOBJS += filter_movit_crop.o
CPPOBJS += filter_movit_deconvolution_sharpen.o
CPPOBJS += filter_movit_diffusion.o
CPPOBJS += filter_movit_flip.o
CPPOBJS += filter_movit_glow.o
CPPOBJS += filter_movit_lift_gamma_gain.o
CPPOBJS += filter_movit_mirror.o
CPPOBJS += filter_movit_opacity.o
CPPOBJS += filter_movit_rect.o
CPPOBJS += filter_movit_resample.o
CPPOBJS += filter_movit_resize.o
CPPOBJS += filter_movit_saturation.o
CPPOBJS += filter_movit_vignette.o
CPPOBJS += filter_movit_white_balance.o
CPPOBJS += mlt_movit_input.o
CPPOBJS += transition_movit_luma.o
CPPOBJS += transition_movit_mix.o
CPPOBJS += transition_movit_overlay.o

CFLAGS += -Wno-deprecated
CFLAGS += $(shell pkg-config --cflags movit 2> /dev/null)
CXXFLAGS += $(CFLAGS)

ifneq (, $(shell $(CXX) --version | grep -is -e g++ -e clang))
    CXXFLAGS += -std=c++11
endif

SHADERDIR = $(shell pkg-config --variable=shaderdir movit)
CXXFLAGS += -DSHADERDIR=\"$(SHADERDIR)\"

LDFLAGS += -L../../mlt++ -lmlt++

ifeq ($(targetos), MinGW)
	CXXFLAGS += $(shell pkg-config --cflags movit)
	LDFLAGS += $(shell pkg-config --libs movit) -lopengl32 -lpthread
else
	LDFLAGS += $(shell pkg-config --libs movit 2> /dev/null)
ifeq ($(targetos), Darwin)
	CXXFLAGS += -FOpenGL
	LDFLAGS += -lpthread -framework OpenGL
else
	OBJS += consumer_xgl.o
	LDFLAGS += -lpthread -lGL -lX11
endif
endif

SRCS := $(OBJS:.o=.c) $(CPPOBJS:.o=.cpp)

all: $(TARGET)

$(TARGET): $(OBJS) $(CPPOBJS)
		$(CXX) $(SHFLAGS) -o $@ $(OBJS) $(CPPOBJS) $(LDFLAGS)

depend:	$(SRCS)
		$(CXX) -MM $(CXXFLAGS) $^ 1>.depend

distclean:	clean
		rm -f .depend config.h config.mak

clean:	
		rm -f $(OBJS) $(TARGET) $(CPPOBJS)

install: all
	install -m 755 $(TARGET) "$(DESTDIR)$(moduledir)"
	install -d "$(DESTDIR)$(mltdatadir)/opengl"
	install -m 644 *.yml "$(DESTDIR)$(mltdatadir)/opengl"

ifneq ($(wildcard .depend),)
include .depend
endif

=== src/modules/plus/CMakeLists.txt ===
set(mltplus_src
    consumer_blipflash.c
    factory.c
    filter_affine.c
    filter_charcoal.c
    filter_dynamictext.c
    filter_dynamic_loudness.c
    filter_invert.c
    filter_lift_gamma_gain.c
    filter_loudness.c
    filter_loudness_meter.c
    filter_lumakey.c
    filter_rgblut.c
    filter_sepia.c
    filter_spot_remover.c
    filter_text.c
    filter_timer.c
    producer_blipflash.c
    producer_count.c
    transition_affine.c)
set(mltplus_lib mlt m Threads::Threads)
if(FFTW_FOUND)
    list(APPEND mltplus_src filter_dance.c filter_fft.c)
    list(APPEND mltplus_lib ${FFTW_LIBRARIES})
endif()
pkg_check_modules(libebur128 IMPORTED_TARGET libebur128)
if(TARGET PkgConfig::libebur128)
    list(APPEND mltplus_lib PkgConfig::libebur128)
    set(mltplus_inc "")
else()
    list(APPEND mltplus_src ebur128/ebur128.c)
    set(mltplus_inc
        ${CMAKE_CURRENT_SOURCE_DIR}/ebur128
        ${CMAKE_CURRENT_SOURCE_DIR}/ebur128/queue)
endif()
add_library(mltplus MODULE ${mltplus_src})
target_link_libraries(mltplus ${mltplus_lib})
target_include_directories(mltplus PRIVATE ${mltplus_inc})
# Create module in parent directory, for the benefit of "source setenv".
set_target_properties(mltplus PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
install(TARGETS mltplus LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
file(GLOB yml *.yml)
install(FILES ${yml}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/plus)

=== debian/changelog ===
mlt (6.22.1-4build1) hirsute; urgency=medium

  * No-change rebuild to build with python3.9 as default.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 19 Nov 2020 18:36:21 +0100

mlt (6.22.1-4) unstable; urgency=medium

  * Enable rubberband feature.
    Closes: #973710

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 05 Nov 2020 10:15:38 +0100

mlt (6.22.1-3) unstable; urgency=medium

  * Add patch from Andreas Metzler to drop unused libexif-gtk-dev build
    dependency.
    Closes: #971663
  * Add patch from Hugh McMaster to make package Multi-Arch compatible.
    Closes: #971752
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 08 Oct 2020 11:42:29 +0200

mlt (6.22.1-2) unstable; urgency=medium

  * Remove deprecated gtk2 dependency.
    Closes: #967633

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 05 Aug 2020 10:58:40 +0200

mlt (6.22.1-1) unstable; urgency=medium

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 04 Aug 2020 10:29:26 +0200

=== debian/control ===
Source: mlt
Priority: optional
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper-compat (= 13),
 ffmpeg,
 libqt5opengl5-dev,
 libqt5svg5-dev,
 ladspa-sdk,
 libavdevice-dev,
 libavformat-dev,
 libdv4-dev,
 libexif-dev,
 libgdk-pixbuf2.0-dev,
 libmovit-dev,
 libfftw3-dev,
 libjack-dev,
 libpango1.0-dev,
 libsamplerate-dev,
 libsdl1.2-dev,
 libsdl2-dev,
 libsox-dev (>= 14.3.0),
 libswscale-dev,
 librubberband-dev,
 libvorbis-dev,
 libvidstab-dev,
 libxine2-dev,
 libxml2-dev,
 librtaudio-dev [linux-any],
 imagemagick,
 frei0r-plugins-dev,
 swig,
 libebur128-dev (>= 1.2.0-2),
 python3-dev,
 dh-python
Standards-Version: 4.5.0
Section: libs
Rules-Requires-Root: no
Homepage: https://www.mltframework.org

Package: libmlt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libmlt6 (= ${binary:Version})
Description: multimedia framework (development)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the static libraries and headers for developing
 applications that use the MLT multimedia framework.

Package: libmlt6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends}
Recommends: libmlt-data (>= ${source:Version})
Description: multimedia framework (runtime)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the files necessary for running applications that
 use the MLT multimedia framework.

Package: libmlt-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Enhances: libmlt6
Description: multimedia framework (data)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the data files for the MLT multimedia framework.

Package: libmlt++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmlt++3 (= ${binary:Version}),
 ${misc:Depends}
Description: MLT multimedia framework C++ wrapper (development)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the static libraries and headers for developing
 applications that use the MLT multimedia framework C++ wrapper.

Package: libmlt++3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: MLT multimedia framework C++ wrapper (runtime)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the files necessary for running applications that
 use the MLT multimedia framework C++ wrapper.

Package: melt
Section: utils
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 libmlt-data (>= ${source:Version})
Description: command line media player and video editor
 melt was meant as a test tool for the MLT framework, but it is also a powerful
 multitrack command line oriented video editor. It could also used as an
 minimalistic media player for audio and video files.

Package: python3-mlt
Architecture: any
Section: python
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python3:Depends}
Provides: ${python3:Provides}
Conflicts: python-mlt
Replaces: python-mlt
Description: multimedia framework (Python bindings)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the Python bindings for the mlt package.

## mlt 6.24.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
+cmake_minimum_required(VERSION 3.14)
 project(MLT)
-set(MLT_VERSION 6.22.1)
-cmake_minimum_required(VERSION 3.10)
+set(MLT_VERSION 6.24.0)
 find_package(PkgConfig REQUIRED)
 include(GNUInstallDirs)
 option(GPL "Enable GPLv2 modules" ON)
@@ -9,9 +9,12 @@
   option(NODEPLOY "Keep bin/ lib/ layout on Windows" ON)
 endif()
 if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86_64)|(AMD64)")
-    set(X86_64 ON)
-    if(NOT MSVC)
-        add_definitions(-DUSE_MMX -DUSE_SSE -DUSE_SSE2 -DARCH_X86_64)
+    if(${ARCH} MATCHES "i686")
+    else()
+        set(X86_64 ON)
+        if(NOT MSVC)
+            add_definitions(-DUSE_MMX -DUSE_SSE -DUSE_SSE2 -DARCH_X86_64)
+        endif()
     endif()
 endif()
 if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
@@ -20,18 +23,19 @@
     add_compile_options(/fp:fast)
 endif()
 find_package(Threads REQUIRED)
-find_package(FFTW QUIET)
+if (WIN32 AND NOT CMAKE_DL_LIBS)
+    find_package(dlfcn-win32 REQUIRED)
+    set(CMAKE_DL_LIBS dlfcn-win32::dl)
+endif()
+pkg_check_modules(FFTW IMPORTED_TARGET fftw3)
 if(NOT FFTW_FOUND)
-    pkg_check_modules(FFTW fftw3)
-endif()
-if(NOT FFTW_FOUND)
-    pkg_check_modules(FFTW fftw)
+    pkg_check_modules(FFTW IMPORTED_TARGET fftw)
 endif()
 pkg_check_modules(xml IMPORTED_TARGET libxml-2.0)
 add_subdirectory(src/framework)
 add_subdirectory(src/melt)
 add_subdirectory(src/mlt++)
-#add_subdirectory(src/swig)
+add_subdirectory(src/swig)
 #file(GLOB modules src/modules/*/)
 set(modules
     src/modules/avformat
@@ -53,6 +57,7 @@
     src/modules/resample
     src/modules/rubberband
     src/modules/rtaudio
+    src/modules/sdl
     src/modules/sdl2
     src/modules/sox
     src/modules/vid.stab

=== Makefile ===
SUBDIRS = src/framework \
		  src/mlt++ \
		  src/melt \
		  src/modules \
		  src/swig \
		  profiles

all clean:
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) -s -C $$subdir depend || exit 1; \
		$(MAKE) -C $$subdir $@ || exit 1; \
	done

distclean:
	rm -f mlt-config packages.dat
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) -C $$subdir $@ || exit 1; \
	done
	echo > config.mak

dist-clean: distclean

include config.mak

install:
	install -d "$(DESTDIR)$(prefix)/bin"
	install -d "$(DESTDIR)$(prefix)/include"
	install -d "$(DESTDIR)$(libdir)"
	install -d "$(DESTDIR)$(moduledir)"
ifeq ($(extra_versioning), true)
	ln -s "$(moduledir)" "$(DESTDIR)$(unversionedmoduledir)"
endif
	install -d "$(DESTDIR)$(libdir)/pkgconfig"
	install -d "$(DESTDIR)$(mltdatadir)"
ifeq ($(extra_versioning), true)
	ln -s "$(mltdatadir)" "$(DESTDIR)$(unversionedmltdatadir)"
endif
	install -c -m 644 *.pc "$(DESTDIR)$(libdir)/pkgconfig"
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) DESTDIR=$(DESTDIR) -C $$subdir $@ || exit 1; \
	done
	cp -R presets "$(DESTDIR)$(mltdatadir)"

uninstall:
	rm -f "$(DESTDIR)$(bindir)"/mlt-config
	rm -f "$(DESTDIR)$(libdir)"/pkgconfig/mlt-framework.pc
	rm -f "$(DESTDIR)$(libdir)"/pkgconfig/mlt++.pc
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) DESTDIR=$(DESTDIR) -C $$subdir $@ || exit 1; \
	done
	rm -rf "$(DESTDIR)$(prefix)/include/mlt"
	rm -rf "$(DESTDIR)$(mltdatadir)"
ifeq ($(compat_dirs), true)
	rm -rf "$(DESTDIR)$(prefix)/share/mlt"
endif

dist:
	git archive --format=tar --prefix=mlt-$(version)/ v$(version) | gzip >mlt-$(version).tar.gz

validate-yml:
	for file in $$(find src/modules -type f -name \*.yml \! -name resolution_scale.yml); do \
		echo "validate: $$file"; \
		kwalify -f src/framework/metaschema.yaml $$file || exit 1; \
	done

codespell:
	codespell -w -q 3 \
    -L shotcut,sav,boundry,percentil,readded,uint,ith,sinc,amin,childs,seeked,writen \
    -S ChangeLog,cJSON.c,cJSON.h,RtAudio.cpp,RtAudio.h,*.rej,mlt_wrap.*

=== src/framework/CMakeLists.txt ===
--- 
+++ 
@@ -5,15 +5,13 @@
 add_library(mlt SHARED ${mlt_src})
 set_target_properties (mlt PROPERTIES SOVERSION ${MLT_VERSION} VERSION 6)
 if(WIN32)
-    find_package(dlfcn-win32 REQUIRED)
-    find_package(iconv REQUIRED)
-    target_link_libraries(mlt dlfcn-win32::dl Iconv::Iconv)
+    find_package(Iconv REQUIRED)
+    target_link_libraries(mlt Iconv::Iconv)
     if(NODEPLOY)
         target_compile_definitions(mlt PRIVATE NODEPLOY)
     endif()
-else()
-    target_link_libraries(mlt dl)
 endif()
+target_link_libraries(mlt ${CMAKE_DL_LIBS})
 if(NOT (WIN32 OR APPLE))
     target_compile_definitions(mlt PRIVATE
         PREFIX_DATA="${CMAKE_INSTALL_FULL_DATADIR}/mlt"
@@ -25,7 +23,8 @@
 target_include_directories(mlt PUBLIC  ${CMAKE_SOURCE_DIR}/src)
 
 if(WIN32)
-    install(TARGETS mlt DESTINATION ${CMAKE_INSTALL_BINDIR})
+    install(TARGETS mlt LIBRARY DESTINATION ${CMAKE_INSTALL_BINDIR})
+    install(TARGETS mlt ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
 else()
     install(TARGETS mlt DESTINATION ${CMAKE_INSTALL_LIBDIR})
 endif()

=== src/framework/Makefile ===
include ../../config.mak
include config.mak

NAME = libmlt$(LIBSUF)
TARGET = $(NAME).$(version)

ifeq ($(targetos), Darwin)
NAME = libmlt$(LIBSUF)
TARGET = libmlt.$(version)$(LIBSUF)
SONAME = libmlt.$(soversion)$(LIBSUF)
SHFLAGS += -install_name $(libdir)/$(SONAME) -current_version $(version) -compatibility_version $(soversion)
else ifeq ($(targetos), MinGW)
NAME = libmlt$(LIBSUF)
TARGET = libmlt-$(soversion)$(LIBSUF)
SHFLAGS += -Wl,--output-def,libmlt.def
else
NAME = libmlt$(LIBSUF)
TARGET = $(NAME).$(version)
SONAME = $(NAME).$(soversion)
SHFLAGS += -Wl,-soname,$(SONAME)
endif

ifeq ($(targetos), Linux)
SHFLAGS += -Wl,--version-script=mlt.vers
endif

OBJS = mlt_audio.o \
	   mlt_frame.o \
	   mlt_version.o \
	   mlt_geometry.o \
	   mlt_deque.o \
	   mlt_property.o \
	   mlt_properties.o \
	   mlt_events.o \
	   mlt_parser.o \
	   mlt_service.o \
	   mlt_producer.o \
	   mlt_multitrack.o \
	   mlt_playlist.o \
	   mlt_consumer.o \
	   mlt_filter.o \
	   mlt_transition.o \
	   mlt_field.o \
	   mlt_tractor.o \
	   mlt_factory.o \
	   mlt_repository.o \
	   mlt_pool.o \
	   mlt_tokeniser.o \
	   mlt_profile.o \
	   mlt_log.o \
	   mlt_cache.o \
	   mlt_animation.o \
	   mlt_slices.o \
	   mlt_luma_map.o

INCS = mlt_audio.h \
	   mlt_consumer.h \
	   mlt_version.h \
	   mlt_factory.h \
	   mlt_filter.h \
	   mlt.h \
	   mlt_multitrack.h \
	   mlt_pool.h \
	   mlt_properties.h \
	   mlt_events.h \
	   mlt_parser.h \
	   mlt_repository.h \
	   mlt_tractor.h \
	   mlt_types.h \
	   mlt_deque.h \
	   mlt_field.h \
	   mlt_frame.h \
	   mlt_geometry.h \
	   mlt_playlist.h \
	   mlt_producer.h \
	   mlt_property.h \
	   mlt_service.h  \
	   mlt_transition.h \
	   mlt_tokeniser.h \
	   mlt_profile.h \
	   mlt_log.h \
	   mlt_cache.h \
	   mlt_animation.h \
	   mlt_slices.h \
	   mlt_luma_map.h

SRCS := $(OBJS:.o=.c)

ifeq ($(targetos), MinGW)
LDFLAGS += -liconv
OBJS += ../win32/win32.o ../win32/strptime.o
SRCS += ../win32/win32.c ../win32/strptime.c
endif

CFLAGS += $(RDYNAMIC) -DPREFIX_DATA="\"$(mltdatadir)\"" -DPREFIX_LIB="\"$(moduledir)\""

LDFLAGS += $(LIBDL) -lpthread -lm

all:	$(TARGET)

$(TARGET): $(OBJS)
		$(CC) $(SHFLAGS) -o $@ $(OBJS) $(LDFLAGS)
		ln -sf $(TARGET) $(NAME)
		if [ "$(targetos)" != "MinGW" ]; then \
			ln -sf $(TARGET) $(SONAME) ; \
		fi

depend:	$(SRCS)
	$(CC) -MM $(CFLAGS) $^ 1>.depend

distclean:	clean
		rm -f .depend

clean:	
		rm -f $(OBJS) $(TARGET) $(NAME) $(SONAME) libmlt.def

install:
	install -d $(DESTDIR)$(libdir)
	if [ "$(targetos)" = "MinGW" ]; then \
		if [ "$(windeploy)" = true ]; then \
			install -m 755 $(TARGET) "$(DESTDIR)$(prefix)" ; \
			install -m 755 $(TARGET) "$(DESTDIR)$(libdir)/libmlt.dll" ; \
		else \
			install -m 755 $(TARGET) "$(DESTDIR)$(bindir)" ; \
			install -m 755 $(TARGET) "$(DESTDIR)$(bindir)/libmlt.dll" ; \
		fi; \
		install -m 644 libmlt.def "$(DESTDIR)$(libdir)" ; \
	else \
		install -m 755 $(TARGET) $(DESTDIR)$(libdir) ; \
		ln -sf $(TARGET) $(DESTDIR)$(libdir)/$(SONAME) ; \
		ln -sf $(TARGET) $(DESTDIR)$(libdir)/$(NAME) ; \
	fi
	install -d "$(DESTDIR)$(prefix)/include/mlt/framework"
	install -m 644 $(INCS) "$(DESTDIR)$(prefix)/include/mlt/framework"
	install -d "$(DESTDIR)$(mltdatadir)"
	install -m 644 metaschema.yaml "$(DESTDIR)$(mltdatadir)"

uninstall:
	rm -f "$(DESTDIR)$(libdir)/$(TARGET)"
	if [ "$(targetos)" != "MinGW" ]; then \
		rm -f "$(DESTDIR)$(libdir)/$(SONAME)" ; \
		rm -f "$(DESTDIR)$(libdir)/$(NAME)" ; \
	else \
		if [ "$(windeploy)" = true ]; then \
			rm -f "$(DESTDIR)$(prefix)/$(TARGET)" ; \
			rm -f "$(DESTDIR)$(libdir)/libmlt.dll" ; \
		else \
			rm -f "$(DESTDIR)$(bindir)/$(TARGET)" ; \
			rm -f "$(DESTDIR)$(bindir)/libmlt.dll" ; \
		fi ; \
		rm -f "$(DESTDIR)$(libdir)/libmlt.def" ; \
	fi
	rm -rf "$(DESTDIR)$(prefix)/include/mlt/framework"
	rm -f "$(DESTDIR)$(mltdatadir)/metaschema.yaml"

ifneq ($(wildcard .depend),)
include .depend
endif

=== src/melt/CMakeLists.txt ===
set(melt_lib mlt Threads::Threads)
pkg_check_modules(sdl2 IMPORTED_TARGET GLOBAL sdl2)
if(TARGET PkgConfig::sdl2)
    add_library(sdl2 ALIAS PkgConfig::sdl2)
    if(MINGW)
        list(APPEND melt_lib mingw32)
    endif()
    list(APPEND melt_lib sdl2)
endif()
add_executable(melt melt.c io.c)
target_compile_definitions(melt PRIVATE VERSION="${MLT_VERSION}")
target_link_libraries(melt ${melt_lib})
install(TARGETS melt RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/mlt++/CMakeLists.txt ===
file(GLOB mlt++_src *.cpp)
add_library(mlt++ SHARED ${mlt++_src})
set_target_properties(mlt++ PROPERTIES SOVERSION 3 VERSION 3 CXX_STANDARD 14)
if(WIN32)
    target_compile_definitions(mlt++ PUBLIC MLTPP_EXPORTS)
endif()
target_include_directories(mlt++ PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../)
target_link_libraries(mlt++ mlt)
if(WIN32)
    install(TARGETS mlt++ LIBRARY DESTINATION ${CMAKE_INSTALL_BINDIR})
    install(TARGETS mlt++ ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
else()
    install(TARGETS mlt++ DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

file(GLOB mlt++_head *.h)
install(FILES ${mlt++_head} DESTINATION include/mlt++)

configure_file(mlt++.pc.in mlt++.pc @ONLY)
install (FILES
    ${CMAKE_CURRENT_BINARY_DIR}/mlt++.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT Development)

=== src/swig/CMakeLists.txt ===
find_package(SWIG)
include(UseSWIG)

set_property(SOURCE mlt.i PROPERTY USE_TARGET_INCLUDE_DIRECTORIES TRUE)
set_property(SOURCE mlt.i PROPERTY CPLUSPLUS ON)

find_package(Python3 COMPONENTS Interpreter Development)

if(Python3_FOUND)
  swig_add_library(pymlt LANGUAGE python SOURCES mlt.i)
  target_include_directories(pymlt PUBLIC ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/mlt++ ${Python3_INCLUDE_DIRS})
  target_link_libraries(pymlt mlt mlt++)
  set_target_properties(pymlt PROPERTIES PREFIX "_" OUTPUT_NAME "mlt")

  if(NOT DEFINED PYTHON_MODULE_PATH)
    if(EXISTS "/etc/debian_version")
      set(PYTHON_MODULE_PATH "lib/python${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR}/dist-packages")
    else()
      set(PYTHON_MODULE_PATH "lib/python${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR}/site-packages")
    endif()
  endif()
  
  install(TARGETS pymlt DESTINATION ${PYTHON_MODULE_PATH})
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mlt.py DESTINATION ${PYTHON_MODULE_PATH})
endif()

=== src/modules/avformat/CMakeLists.txt ===
#list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
#find_package(FFmpeg)
pkg_check_modules(libavformat IMPORTED_TARGET libavformat)
pkg_check_modules(libswscale IMPORTED_TARGET libswscale)
pkg_check_modules(libavutil IMPORTED_TARGET libavutil)
if(     TARGET PkgConfig::libavformat
    AND TARGET PkgConfig::libswscale
    AND TARGET PkgConfig::libavutil)
    set(mltavformat_libs
        mlt m Threads::Threads
        PkgConfig::libavformat
        PkgConfig::libswscale
        PkgConfig::libavutil)
    set(mltavformat_defs FILTERS)
    if(WIN32)
        list(APPEND mltavformat_defs AVDATADIR="share/ffmpeg/")
    endif()
    set(mltavformat_srcs
        common.c
        factory.c
        filter_avcolour_space.c
        filter_avdeinterlace.c
        filter_swscale.c)
    pkg_check_modules(libavcodec IMPORTED_TARGET libavcodec)
    if(TARGET PkgConfig::libavcodec)
        list(APPEND mltavformat_libs PkgConfig::libavcodec)
        list(APPEND mltavformat_defs CODECS)
        list(APPEND mltavformat_srcs
            producer_avformat.c
            consumer_avformat.c)
    endif()
    pkg_check_modules(libavfilter IMPORTED_TARGET libavfilter)
    if(TARGET PkgConfig::libavfilter)
        list(APPEND mltavformat_libs PkgConfig::libavfilter)
        list(APPEND mltavformat_defs FILTERS AVFILTER )
        list(APPEND mltavformat_srcs
            filter_avfilter.c)
    endif()
    pkg_check_modules(libavdevice IMPORTED_TARGET libavdevice)
    if(TARGET PkgConfig::libavdevice)
        list(APPEND mltavformat_libs PkgConfig::libavdevice)
        list(APPEND mltavformat_defs AVDEVICE)
    endif()
    pkg_check_modules(libswresample IMPORTED_TARGET libswresample)
    if(TARGET PkgConfig::libswresample)
        list(APPEND mltavformat_libs PkgConfig::libswresample)
        list(APPEND mltavformat_defs SWRESAMPLE)
        list(APPEND mltavformat_srcs
            filter_swresample.c)
    endif()
    add_library(mltavformat MODULE ${mltavformat_srcs})
    target_link_libraries(mltavformat ${mltavformat_libs})
    target_compile_definitions(mltavformat PRIVATE ${mltavformat_defs})
    # Create module in parent directory, for the benefit of "source setenv".
    set_target_properties(mltavformat PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
    install(TARGETS mltavformat LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
    install(FILES blacklist.txt producer_avformat.yml consumer_avformat.yml yuv_only.txt resolution_scale.yml
        DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/avformat)
endif()

=== src/modules/avformat/Makefile ===
CFLAGS += -I../..
LDFLAGS += -L../../framework -lmlt -lpthread -lm

ifneq (, $(shell $(CC) --version | grep -is -e 'Free Software Foundation'))
	LDFLAGS += -latomic
endif

include ../../../config.mak
include config.mak

LDFLAGS += $(EXTRA_LIBS)

ifndef CODECS
TARGET = ../libmltffmpeg$(LIBSUF)
else
TARGET = ../libmltavformat$(LIBSUF)
endif

OBJS = common.o \
       factory.o

ifdef FILTERS
OBJS += filter_avcolour_space.o \
	    filter_avdeinterlace.o \
	    filter_swscale.o
CFLAGS += -DFILTERS
endif

ifdef VDPAU
CFLAGS += -DVDPAU $(shell pkg-config pkg-config --cflags x11)
LDFLAGS += $(LIBDL) $(shell pkg-config pkg-config --libs x11)
endif

ifdef CODECS
OBJS += producer_avformat.o \
	    consumer_avformat.o
CFLAGS += -DCODECS
endif

ifdef DEVICES
CFLAGS += -DAVDEVICE
endif

ifdef AVFILTER
CFLAGS += -DAVFILTER
OBJS += filter_avfilter.o
endif

ifdef SWRESAMPLE
OBJS += filter_swresample.o
CFLAGS += -DSWRESAMPLE
endif

SRCS := $(OBJS:.o=.c)

all: 	$(TARGET)

$(TARGET): $(OBJS)
	$(CC) $(SHFLAGS) -o $@ $(OBJS) $(LDFLAGS)

depend:	$(SRCS)
	$(CC) -MM $(CFLAGS) $^ 1>.depend

distclean:	clean
	rm -f .depend

clean:	
	rm -f $(OBJS) ../libmltffmpeg$(LIBSUF) ../libmltavformat$(LIBSUF)

install: all
	install -m 755 $(TARGET) "$(DESTDIR)$(moduledir)"
	install -d "$(DESTDIR)$(mltdatadir)/avformat"
	install -m 644 blacklist.txt "$(DESTDIR)$(mltdatadir)/avformat"
	install -m 644 yuv_only.txt "$(DESTDIR)$(mltdatadir)/avformat"
	install -m 644 producer_avformat.yml "$(DESTDIR)$(mltdatadir)/avformat"
	install -m 644 consumer_avformat.yml "$(DESTDIR)$(mltdatadir)/avformat"

uninstall:
	rm -f "$(DESTDIR)$(moduledir)/libmltavformat$(LIBSUF)"
	rm -f "$(DESTDIR)$(moduledir)/libmltffmpeg$(LIBSUF)"
	rm -rf "$(DESTDIR)$(mltdatadir)/avformat"

ifneq ($(wildcard .depend),)
include .depend
endif

=== src/modules/core/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,11 @@
     list(APPEND mltcore_src ${CMAKE_SOURCE_DIR}/src/win32/fnmatch.c)
     list(APPEND mltcore_inc ${CMAKE_SOURCE_DIR}/src/win32)
 endif()
+
+if(NOT X86_64)
+    list(REMOVE_ITEM mltcore_src ${CMAKE_CURRENT_SOURCE_DIR}/composite_line_yuv_sse2_simple.c)
+endif()
+
 add_library(mltcore MODULE ${mltcore_src})
 target_include_directories(mltcore PRIVATE ${mltcore_inc})
 target_link_libraries(mltcore mlt Threads::Threads)

=== src/modules/core/Makefile ===
CFLAGS += -I../..

LDFLAGS += -L../../framework -lmlt -lm -lpthread

include ../../../config.mak

TARGET = ../libmltcore$(LIBSUF)

OBJS = factory.o \
	   producer_colour.o \
	   producer_consumer.o \
	   producer_hold.o \
	   producer_loader.o \
	   producer_melt.o \
	   producer_noise.o \
	   producer_timewarp.o \
	   producer_tone.o \
	   filter_audiochannels.o \
	   filter_audiomap.o \
	   filter_audioconvert.o \
	   filter_audiowave.o \
	   filter_brightness.o \
	   filter_channelcopy.o \
	   filter_choppy.o \
	   filter_crop.o \
	   filter_data_feed.o \
	   filter_data_show.o \
	   filter_fieldorder.o \
	   filter_gamma.o \
	   filter_greyscale.o \
	   filter_imageconvert.o \
	   filter_luma.o \
       filter_mask_apply.o \
       filter_mask_start.o \
	   filter_mirror.o \
	   filter_mono.o \
	   filter_obscure.o \
	   filter_panner.o \
	   filter_region.o \
	   filter_rescale.o \
	   filter_resize.o \
	   filter_transition.o \
	   filter_watermark.o \
	   transition_composite.o \
	   transition_luma.o \
	   transition_mix.o \
	   transition_region.o \
	   transition_matte.o \
	   consumer_multi.o \
	   consumer_null.o

ifdef SSE2_FLAGS
ifdef ARCH_X86_64
OBJS += composite_line_yuv_sse2_simple.o
endif
endif

ASM_OBJS = 

SRCS := $(OBJS:.o=.c)

ifeq ($(targetos), MinGW)
CFLAGS += -I../../win32
OBJS += ../../win32/fnmatch.o
SRCS += ../../win32/fnmatch.c
endif

all: 	$(TARGET)

$(TARGET): $(OBJS) $(ASM_OBJS)
	$(CC) $(SHFLAGS) -o $@ $(OBJS) $(ASM_OBJS) $(LDFLAGS)

composite_line_yuv_mmx.o: composite_line_yuv_mmx.S
	$(CC) -o $@ -c composite_line_yuv_mmx.S

depend:	$(SRCS)
	$(CC) -MM $(CFLAGS) $^ 1>.depend

distclean:	clean
	rm -f .depend

clean:	
	rm -f $(OBJS) $(ASM_OBJS) $(TARGET)

install: all
	install -m 755 $(TARGET) "$(DESTDIR)$(moduledir)"
	install -d "$(DESTDIR)$(mltdatadir)/core"
	install -m 644 data_fx.properties "$(DESTDIR)$(mltdatadir)/core"
	install -m 644 loader.dict "$(DESTDIR)$(mltdatadir)/core"
	install -m 644 loader.ini "$(DESTDIR)$(mltdatadir)/core"
	install -m 644 *.yml "$(DESTDIR)$(mltdatadir)/core"

ifneq ($(wildcard .depend),)
include .depend
endif

=== src/modules/decklink/CMakeLists.txt ===
file(GLOB mltdecklink_src *.cpp)
if(WIN32)
    list(APPEND mltdecklink_src win/DeckLinkAPI_i.cpp)
    set(mltdecklink_inc ${CMAKE_CURRENT_SOURCE_DIR}/win)
elseif(APPLE)
    list(APPEND mltdecklink_src darwin/DeckLinkAPIDispatch.cpp)
    set(mltdecklink_inc ${CMAKE_CURRENT_SOURCE_DIR}/darwin)
else()
    list(APPEND mltdecklink_src linux/DeckLinkAPIDispatch.cpp)
    set(mltdecklink_inc ${CMAKE_CURRENT_SOURCE_DIR}/linux)
endif()
add_library(mltdecklink MODULE ${mltdecklink_src})
target_link_libraries(mltdecklink mlt Threads::Threads)
target_include_directories(mltdecklink PRIVATE ${mltdecklink_inc})
# Create module in parent directory, for the benefit of "source setenv".
set_target_properties(mltdecklink PROPERTIES LIBRARY_OUTPUT_DIRECTORY ..)
install(TARGETS mltdecklink LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
file(GLOB yml *.yml)
install(FILES ${yml} DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/decklink)

=== debian/changelog ===
mlt (6.24.0-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Fri, 05 Feb 2021 22:43:41 -0500

mlt (6.24.0-1) unstable; urgency=medium

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 08 Dec 2020 16:29:36 +0100

mlt (6.22.1-5) unstable; urgency=medium

  * Bump Standards-Version to 4.5.1.
  * Update debian/watch file standard to version 4.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 19 Nov 2020 14:58:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: mlt
 Priority: optional
-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
+XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
 Build-Depends: debhelper-compat (= 13),
  ffmpeg,
  libqt5opengl5-dev,
@@ -32,7 +33,7 @@
  libebur128-dev (>= 1.2.0-2),
  python3-dev,
  dh-python
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://www.mltframework.org

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Enable MMX and SSE on amd64 architecture
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), "amd64"))
	EXTRA_CONFIGURE_OPTS += --enable-mmx --enable-sse
else
	EXTRA_CONFIGURE_OPTS += --disable-mmx --disable-sse --disable-sse2
endif

DEB_CONFIGURE_EXTRA_FLAGS := \
	--enable-gpl \
	--enable-gpl3 \
	--enable-motion_est \
	$(EXTRA_CONFIGURE_OPTS) \
	--avformat-shared=/usr \
	--swig-languages=python \
	--qimage-libdir=/usr/lib \
	--disable-swfdec

PYTHON_DIR := usr/lib/python3/dist-packages

%:
	dh $@ --with python3

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

override_dh_auto_clean:
	[ ! -f config.mak ] || $(MAKE) distclean

override_dh_install:
	mkdir -p debian/python3-mlt/$(PYTHON_DIR)
	install -m 644 src/swig/python/mlt.py debian/python3-mlt/$(PYTHON_DIR)/mlt.py
	install -m 644 src/swig/python/_mlt.so debian/python3-mlt/$(PYTHON_DIR)/_mlt.so
	dh_install

override_dh_makeshlibs:
	dh_makeshlibs -V
